/* 
 * The contents of this file are subject to the Mozilla Public
 * License Version 1.1 (the "License"); you may not use this file
 * except in compliance with the License. You may obtain a copy of
 * the License at http://www.mozilla.org/MPL/
 * 
 * Software distributed under the License is distributed on an "AS
 * IS" basis, WITHOUT WARRANTY OF ANY KIND, either express or
 * implied. See the License for the specific language governing
 * rights and limitations under the License.
 * 
 * The Original Code is useragent toolbar
 *
 * The Initial Developer of the installation and overaly doce is 
 * David Illsely <illsleydc@bigfoot.com>
 * Portions created by David Illsley are Copyright (C) 2001
 * David Illsley. All Rights Reserved.
 * Combination of gesture code and toolbar done by
 * Andy Edmonds <aedmonds@mindspring.com>
 * 
 * Contributor(s): David Illsley <illsleydc@bigfoot.com>
 * 
 * Alternatively, the contents of this file may be used under the
 * terms of the GNU General Public License Version 2 or later (the
 * "GPL"), in which case the provisions of the GPL are applicable 
 * instead of those above.  If you wish to allow use of your 
 * version of this file only under the terms of the GPL and not to
 * allow others to use your version of this file under the MPL,
 * indicate your decision by deleting the provisions above and
 * replace them with the notice and other provisions required by
 * the GPL.  If you do not delete the provisions above, a recipient
 * may use your version of this file under either the MPL or the
 * GPL.
 */

/* Mouse Gesture for Mozilla
 * uses standard DOM methods. 
 * Contributor(s): 
 * Pavol Vaskovic <pali@pali.sk> (original author)
 * Tim Williamson [chsman@hotmail.com] (revised)
 *
 * Gesture implementations from:
 * squarefree.com, bookmarklets.com, Jeremy Wrinkle (exotrip), Andy Edmonds
 */
 
 /* mozgest Toolbar
  * Contributotrs:
  * Andy Edmonds <aedmonds@mindspring.com> (original author)
  * Pavol Vaskovic <pali@pali.sk>
  */
 
var condition = new String; // mouse gesture condition (button number and modifier keys)
var minGrid; // grid size; minimal gesture has to be minGrid pixels long
var gestureInProgress = false;
var old_x;
var old_y;
var gesture;
var lastgesture;
var mozgestDebug = true;
var globalOnLink = false;
var inContent = false;
// lets get our preferences interface as global var for all our functions
var pref = Components.classes["@mozilla.org/preferences;1"].getService(Components.interfaces.nsIPref);

function mozgestInit() {
  window.removeEventListener("load", mozgestInit, true);

  // set Defaults on the first run
  try {
    mozgestReadPref();  
  }
  catch(e) {
    dump("Setting Default MozGest Preferences.\n")
    pref.SetBoolPref("mozgest.on", true);
    pref.SetBoolPref("mozgest.debug", false);
    pref.SetBoolPref("mozgest.modifier.ctrl", false);
    pref.SetBoolPref("mozgest.modifier.alt", false);
    pref.SetBoolPref("mozgest.modifier.shift", false);
    pref.SetIntPref("mozgest.mousebutton", 0);
    pref.SetIntPref("mozgest.mingrid", 15);
    mozgestReadPref();
  }
  
  // Turn it on at load if necessary
  if(pref.GetBoolPref("mozgest.on")) mozgestOn(); 
}

function mozgestOn(){
  setPref();
  addWindowWatch();
  if(mozgestDebug) mozgestDebugText("MozGest is: On");
  window.status="MozGest is: On";
}

function mozgestOff() {
 setPref();
 removeWindowWatch();
 if(mozgestDebug) mozgestDebugText("MozGest is: Off");
 window.status="MozGest is: Off";
}

// Need not found yet, currently assumes a 
// A HREF is only one node above e.target
function findHref(domPosition) {
  if(domPosition.nodeName == "A") {
  }
  else {

 }
}

function processCoordinates(e){
  var x_dir = parseInt((e.clientX-old_x)/minGrid);
  var y_dir = parseInt((e.clientY-old_y)/minGrid);
  
  //only add if movement enough to make a gesture
  if ((x_dir != 0) || (y_dir != 0))
  {
    var last_dir = gesture[gesture.length-1];
    if (x_dir > 0 && last_dir != "R")
      gesture.push("R");
    else if (x_dir < 0 && last_dir != "L")
      gesture.push("L");
    else if (y_dir > 0 && last_dir != "D")
      gesture.push("D");
    else if (y_dir < 0 && last_dir != "U")
      gesture.push("U");
    old_x = e.clientX;
    old_y = e.clientY;
    window.status="Gesture: " + gesture;
  }

  ifALinkTarget = e.target.parentNode;
  if(mozgestDebug) dump('// --- mozgest Target mousedown is ' + etarget + '\n')
  //dumpProperties(ifALinkTarget);
  if(ifALinkTarget.nodeName == "A") {
  //dump(' found link underneath \n');
    if(!globalOnLink) globalOnLink = new Array();
 if(!mozgestCheckLinkDups(ifALinkTarget.href)) globalOnLink.push(ifALinkTarget.href);
 //dump(' link array is ' + globalOnLink + '\n');
 }
}

function mozgestCheckLinkDups(addy) {
  var isADup = false;
  for(var zz = 0; zz < globalOnLink.length; zz++) {
    if(globalOnLink[zz] == addy) isADup = true;
  }
  return isADup;
}

function mozgestStack(addy) {
window.moveTo(0,0); // outerWidth
window.resizeTo(screen.availWidth/2, screen.availHeight);
var mozgester = window.open(addy);
mozgester.moveTo(screen.availWidth/2 + 1, 0);
mozgester.resizeTo(screen.availWidth/2,screen.availHeight);
//dumpProperties(screen);
}

function startGesture(e){
 if (inContent){
  if (eval(condition)){
    ifALinkTarget = e.target.parentNode;
    if(ifALinkTarget.nodeName == "A") {
      if(!globalOnLink) globalOnLink = new Array();
      if(!mozgestCheckLinkDups(ifALinkTarget.href))
        globalOnLink.push(ifALinkTarget.href);
     }
    if(mozgestDebug) dump('// --- mozgest Target mousedown is ' +
      e.currentTarget + ' vs ' + e.target + '\n')

    etarget = e.currentTarget.toString();
  //  && (etarget.indexOf('XULElem') < 0 )
    if ((e.clientX+30<window.innerWidth) && (etarget.indexOf('InputEle')<0)){
      gestureInProgress = true;
      old_x = e.clientX;
      old_y = e.clientY;
      gesture = new Array;
      window.addEventListener("mousemove", processCoordinates, false);
    }
  }
  inContent = false;
 }
}
    
function endGesture(e){
  if (gestureInProgress) {
  	if(globalOnLink) dump('ending gesture with '+globalOnLink[length -1]+' \n');
    window.removeEventListener("mousemove", processCoordinates, false);
    lastgesture = gesture.join("");
    if (lastgesture != ""){
      /* we should stop default actions here (popup menus, text selecting)
       but I think that current Mozilla implementation does those things
       internaly, so we can not stop them from DOM. */
    	e.preventDefault();
      e.stopPropagation();
      fireGesture(lastgesture);
    }
    else if(mozgestDebug) mozgestDebugText("Gesture was too small");
    gestureInProgress = false;
    globalOnLink = false;
  } 
}

function mozgestWritePref(){ 
  if (document.getElementById("mozgestOnOff").getAttribute("checked"))
    pref.SetBoolPref("mozgest.on", true);  
  else pref.SetBoolPref("mozgest.on", false);

  if(document.getElementById("mozgestDebug").getAttribute("checked"))
    pref.SetBoolPref("mozgest.debug", true);
  else pref.SetBoolPref("mozgest.debug", false);
  
  for(i=0;i<3;i++) if (document.getElementById("mb"+i).getAttribute("checked"))
    pref.SetIntPref("mozgest.mousebutton", i);

  if (document.getElementById("ctrlKey").getAttribute("checked"))
    pref.SetBoolPref("mozgest.modifier.ctrl", true);
  else pref.SetBoolPref("mozgest.modifier.ctrl", false);

  if (document.getElementById("altKey").getAttribute("checked"))
    pref.SetBoolPref("mozgest.modifier.alt", true);
  else pref.SetBoolPref("mozgest.modifier.alt", false);

  if (document.getElementById("shiftKey").getAttribute("checked"))
    pref.SetBoolPref("mozgest.modifier.shift", true);
  else pref.SetBoolPref("mozgest.modifier.shift", false);
  
  pref.SetIntPref("mozgest.mingrid", document.getElementById("minGrid").getAttribute("value"));
}

function mozgestReadPref(){
  if (pref.GetBoolPref("mozgest.on"))
    document.getElementById("mozgestOnOff").setAttribute("checked", "true");
  else document.getElementById("mozgestOnOff").removeAttribute("checked");

  if(pref.GetBoolPref("mozgest.debug")) {
    mozgestDebug = true;
    document.getElementById("mozgestDebug").setAttribute("checked", "true");
    document.getElementById("mozgestDebugText").removeAttribute("collapsed");
  }
  else {
    mozgestDebug = false;
    document.getElementById("mozgestDebug").removeAttribute("checked");
    document.getElementById("mozgestDebugText").setAttribute("collapsed","true");
  }

  for(i=0;i<3;i++){
    if (i == pref.GetIntPref("mozgest.mousebutton")){
      document.getElementById("mb" + i).setAttribute("checked", "true");
      condition = document.getElementById('mb'+ i).getAttribute("value");
    }
    else document.getElementById("mb" + i).removeAttribute("checked");
  }

  if (pref.GetBoolPref("mozgest.modifier.ctrl")){
    document.getElementById("ctrlKey").setAttribute("checked","true");
    document.getElementById("mozgestMod").setAttribute("checked","true");
    condition += " && " + document.getElementById("ctrlKey").getAttribute("value");
  }
  else  document.getElementById("ctrlKey").removeAttribute("checked");
  
  if (pref.GetBoolPref("mozgest.modifier.alt")){
    document.getElementById("altKey").setAttribute("checked","true");
    document.getElementById("mozgestMod").setAttribute("checked","true");
    condition += " && " + document.getElementById("altKey").getAttribute("value");
  }
  else  document.getElementById("altKey").removeAttribute("checked");
  
  if (pref.GetBoolPref("mozgest.modifier.shift")){
    document.getElementById("shiftKey").setAttribute("checked","true");
    document.getElementById("mozgestMod").setAttribute("checked","true");
    condition += " && " + document.getElementById("shiftKey").getAttribute("value");
  }
  else  document.getElementById("shiftKey").removeAttribute("checked");
    
  document.getElementById('minGrid').setAttribute("value", pref.GetIntPref("mozgest.mingrid"));
  minGrid = pref.GetIntPref("mozgest.mingrid");
}

function setPref(){
  mozgestWritePref();
  mozgestReadPref();
}

function addWindowWatch() {
  window.addEventListener("mousedown", startGesture, false);
  window.addEventListener("mouseup", endGesture, false);
  if (mozgestDebug) dump('\\---- Adding Listener---\\\ \n');
}

function removeWindowWatch() {
  window.removeEventListener("mousedown", startGesture, false);
  window.removeEventListener("mouseup", endGesture, false);
  if (mozgestDebug) dump('\\---- Removing Listener---\\\ \n');
}

function mozgestOnOff(){
  obj = document.getElementById("mozgestOnOff");
  if (mozgestDebug) dump("On/Off Checkbox is checked: "+obj.getAttribute("checked"));
  if (obj.getAttribute("checked")) mozgestOn();
  else mozgestOff(); 
}
  
function mozgestMod(what){
  if (what == "over")
    document.getElementById("mozgestMod").setAttribute("checked","true");
  if (what == "out" &&
      !document.getElementById("ctrlKey").getAttribute("checked") &&
      !document.getElementById("altKey").getAttribute("checked") &&
      !document.getElementById("shiftKey").getAttribute("checked"))
    document.getElementById("mozgestMod").setAttribute("checked","false");
}

function mozgestDebugText(msg){
  msgbox = document.getElementById("mozgestDebugText");
  msgbox.setAttribute("value", (msg + "\n") + msgbox.getAttribute("value"));
}

function mozgestIsInContent(){
  inContent = true;
}